/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalyticsControllerActionViewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalyticsControllerActionViewRequest{}

// GoogleAnalyticsControllerActionViewRequest struct for GoogleAnalyticsControllerActionViewRequest
type GoogleAnalyticsControllerActionViewRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	AccountId  *int32  `json:"accountId,omitempty"`
	PropertyId *string `json:"propertyId,omitempty"`
}

// NewGoogleAnalyticsControllerActionViewRequest instantiates a new GoogleAnalyticsControllerActionViewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalyticsControllerActionViewRequest() *GoogleAnalyticsControllerActionViewRequest {
	this := GoogleAnalyticsControllerActionViewRequest{}
	return &this
}

// NewGoogleAnalyticsControllerActionViewRequestWithDefaults instantiates a new GoogleAnalyticsControllerActionViewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalyticsControllerActionViewRequestWithDefaults() *GoogleAnalyticsControllerActionViewRequest {
	this := GoogleAnalyticsControllerActionViewRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionViewRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalyticsControllerActionViewRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionViewRequest) GetAccountId() int32 {
	if o == nil || IsNil(o.AccountId) {
		var ret int32
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) GetAccountIdOk() (*int32, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given int32 and assigns it to the AccountId field.
func (o *GoogleAnalyticsControllerActionViewRequest) SetAccountId(v int32) {
	o.AccountId = &v
}

// GetPropertyId returns the PropertyId field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionViewRequest) GetPropertyId() string {
	if o == nil || IsNil(o.PropertyId) {
		var ret string
		return ret
	}
	return *o.PropertyId
}

// GetPropertyIdOk returns a tuple with the PropertyId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) GetPropertyIdOk() (*string, bool) {
	if o == nil || IsNil(o.PropertyId) {
		return nil, false
	}
	return o.PropertyId, true
}

// HasPropertyId returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionViewRequest) HasPropertyId() bool {
	if o != nil && !IsNil(o.PropertyId) {
		return true
	}

	return false
}

// SetPropertyId gets a reference to the given string and assigns it to the PropertyId field.
func (o *GoogleAnalyticsControllerActionViewRequest) SetPropertyId(v string) {
	o.PropertyId = &v
}

func (o GoogleAnalyticsControllerActionViewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalyticsControllerActionViewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.PropertyId) {
		toSerialize["propertyId"] = o.PropertyId
	}
	return toSerialize, nil
}

type NullableGoogleAnalyticsControllerActionViewRequest struct {
	value *GoogleAnalyticsControllerActionViewRequest
	isSet bool
}

func (v NullableGoogleAnalyticsControllerActionViewRequest) Get() *GoogleAnalyticsControllerActionViewRequest {
	return v.value
}

func (v *NullableGoogleAnalyticsControllerActionViewRequest) Set(val *GoogleAnalyticsControllerActionViewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalyticsControllerActionViewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalyticsControllerActionViewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalyticsControllerActionViewRequest(val *GoogleAnalyticsControllerActionViewRequest) *NullableGoogleAnalyticsControllerActionViewRequest {
	return &NullableGoogleAnalyticsControllerActionViewRequest{value: val, isSet: true}
}

func (v NullableGoogleAnalyticsControllerActionViewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalyticsControllerActionViewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
